## mlpost 0.7.1

=== examples/Makefile ===
# all files that are generated from boxes.ml
BOXPNGFILES := simple.png f1.png f2.png traffic.png hierarchy.png custom.png
BOXOUTFILES := $(BOXPNGFILES:.png=.1)

# all files that are generated from paths.ml
PATHPNGFILES := path1.png path2.png path3.png path4.png path5.png \
		  path6.png path7.png path8.png path9.png path10.png\
		  path11.png path12.png path13.png path14.png path15.png\
		  cheno11.png cheno14.png
PATHOUTFILES := $(PATHPNGFILES:.png=.1)

# all files that are generated from misc.ml
MISCPNGFILES := bresenham.png cfg.png chess.png diag1.png diag2.png\
		drums.png escher.png other208.png proval.png\
		randtree.png rubik.png test.png lattice.png football.png
MISCOUTFILES := $(MISCPNGFILES:.png=.1)

# all files that are generated from tree.ml
TREEPNGFILES := tree1.png tree2.png tree3.png tree4.png tree5.png \
                tree6.png tree7.png
TREEOUTFILES := $(TREEPNGFILES:.png=.1)

# all files that are generated from labels.ml
LABELPNGFILES := handbook3.png other27.png
LABELOUTFILES := $(LABELPNGFILES:.png=.1)

# all files that are generated from automata.ml
AUTOMPNGFILES := automaton1.png automaton2.png automaton4.png 
AUTOMOUTFILES := $(AUTOMPNGFILES:.png=.1)

HISTPNGFILES := hist1.png
HISTOUTFILES := $(HISTPNGFILES:.png=.1)

RADARPNGFILES := radar1.png radar2.png
RADAROUTFILES := $(RADARPNGFILES:.png=.1)

HTMLFILES := boxes.ml.html paths.ml.html misc.ml.html tree.ml.html \
             label.ml.html automata.ml.html hist.ml.html radar.ml.html

CAIRO := cairo_test.ml

MLPOST:=mlpost -v -ps

all: $(BOXPNGFILES) $(PATHPNGFILES) $(MISCPNGFILES) \
     $(TREEPNGFILES) $(LABELPNGFILES) $(AUTOMPNGFILES) $(HISTPNGFILES) \
     $(RADARPNGFILES)
html: $(HTMLFILES)
%.ml.html : %.ml parse
	caml2html -hc -ext "parse:./parse" $*.ml


%.png: %.ps
	convert $*.ps $@ 

%.ps: %.1 all.template
	sed -e 's/all/$*/' all.template > $*.tex
	latex $*
	dvips -E $*.dvi -o

automaton4.ps: automaton4.1 
	latex automaton4.tex
	dvips -E automaton4.dvi -o

# dangerous - might be called more than once or even at the same time
$(BOXOUTFILES): boxes.dummy
$(PATHOUTFILES): paths.dummy
$(MISCOUTFILES): misc.dummy
$(TREEOUTFILES): tree.dummy
$(LABELOUTFILES): label.dummy
$(AUTOMOUTFILES): automata.dummy
$(HISTOUTFILES): hist.dummy
$(RADAROUTFILES): radar.dummy


%.dummy: %.ml
	$(MLPOST) $^
	touch $@

parse.ml: parse.mll
	ocamllex parse.mll

parse: parse.ml
	ocamlopt.opt -o parse parse.ml

BOXTEXFILES:=$(BOXPNGFILES:.png=.tex)
PATHTEXFILES:=$(PATHPNGFILES:.png=.tex)
MISCTEXFILES:=$(MISCPNGFILES:.png=.tex)
TREETEXFILES:=$(TREEPNGFILES:.png=.tex)
LABELTEXFILES:=$(LABELPNGFILES:.png=.tex)
clean:
	rm -f *.aux *.dvi *.ps *.1 *.log $(PNGFILES) *.mp *.mpx
	rm -f $(BOXTEXFILES) $(PATHTEXFILES) $(MISCTEXFILES) $(TREETEXFILES)
	rm -f $(LABELTEXFILES)
	rm -f automaton1.tex automaton2.tex
	# do not remove automaton4.tex - it's handmade
	rm -f boxes.ml.html paths.ml.html misc.ml.html tree.ml.html label.ml.html
	rm -f parse.ml *.cmx *.cmo *.cmi parse *.o
	rm -f *.png *.dummy

## mlpost 0.7.4

=== examples/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 # all files that are generated from boxes.ml
-BOXPNGFILES := simple.png f1.png f2.png traffic.png hierarchy.png custom.png
+BOXPNGFILES := simple.png f1.png f2.png traffic.png hierarchy.png custom.png\
+		place.png
 BOXOUTFILES := $(BOXPNGFILES:.png=.1)
 
 # all files that are generated from paths.ml
@@ -17,7 +18,8 @@
 
 # all files that are generated from tree.ml
 TREEPNGFILES := tree1.png tree2.png tree3.png tree4.png tree5.png \
-                tree6.png tree7.png
+                tree6.png tree7.png tree8.png tree9.png tree10.png \
+		tree11.png
 TREEOUTFILES := $(TREEPNGFILES:.png=.1)
 
 # all files that are generated from labels.ml

=== debian/changelog ===
mlpost (0.7.4-1build1) lucid; urgency=low

  * No-change rebuild for OCaml 3.11.2 transition (LP: #529408).

 -- Ilya Barygin <barygin@gmail.com>  Sun, 28 Feb 2010 20:03:02 +0300

mlpost (0.7.4-1) unstable; urgency=low

  * New upstream release
  * debian/patches:
    - remove Fix-manpage-double-UTF8-encoding.patch (merged)
    - remove Fix-build-when-ocamlopt-is-missing.patch (merged)
    - add No-tracingchoices-in-generated-MetaPost-sources.patch
      (Closes: #562358)
  * debian/control:
    - update my e-mail address, remove DMUA
    - update Standards-Version to 3.8.3
  * Switch to dh-ocaml 0.9
  * Switch source package format to 3.0 (quilt)
  * Fix watch file

 -- Stéphane Glondu <glondu@debian.org>  Fri, 25 Dec 2009 11:51:05 +0100

mlpost (0.7.1-2) unstable; urgency=low

  * Add a patch to fix FTBFS on bytecode architectures

 -- Stephane Glondu <steph@glondu.net>  Thu, 13 Aug 2009 13:39:54 +0200

mlpost (0.7.1-1) unstable; urgency=low

  * New upstream release:
    - update debian/copyright
    - debian/control:
      + new dependencies: libcairo-ocaml-dev, libbitstring-ocaml-dev
      + new build-deps: camlp4, texlive-*, imagemagick, ghostscript
    - add a patch to fix double UTF8-encoding in manpage:
      + add build-dependency to quilt, and README.source

 -- Stephane Glondu <steph@glondu.net>  Tue, 11 Aug 2009 23:13:03 +0200

mlpost (0.6-3) unstable; urgency=low

  * Add dependency to context (needed for mp-tool.mp)
  * Update Standards-Version to 3.8.2
  * debian/rules: use ocaml.mk as a rules file

 -- Stephane Glondu <steph@glondu.net>  Sat, 27 Jun 2009 20:56:35 +0200

mlpost (0.6-2) unstable; urgency=low

  * First upload to unstable
  * Bump Standards-Version to 3.8.1 (no changes)

 -- Stephane Glondu <steph@glondu.net>  Sun, 22 Mar 2009 14:05:13 +0100

mlpost (0.6-1) experimental; urgency=low

  * Initial release (Closes: #513972)

 -- Stephane Glondu <steph@glondu.net>  Sun, 08 Feb 2009 13:04:13 +0100

=== debian/control ===
Source: mlpost
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 context,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-metapost,
 ghostscript,
 imagemagick,
 debhelper (>= 7),
 dh-ocaml (>= 0.9~),
 cdbs,
 libcairo-ocaml-dev (>= 20090223-2~),
 libbitstring-ocaml-dev (>= 2.0.0-5~),
 camlp4,
 ocaml-nox (>= 3.11.1-3~)
Standards-Version: 3.8.3
Section: tex
Homepage: http://mlpost.lri.fr/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/mlpost.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/mlpost.git

Package: mlpost
Architecture: any
Depends:
 context,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-metapost,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 xpdf
Suggests:
 ghostscript,
 imagemagick,
 ocaml-findlib
Description: Objective Caml interface to Metapost
 Mlpost is an OCaml library for scientific drawing. It relies on
 Metapost, giving the possibility to include (La)TeX fragments.
 Mlpost users can use the full power of OCaml to generate their
 diagrams, including static typing and the possibility to use any
 OCaml library. Moreover, Mlpost promotes a declarative style quite
 different from existing tools.
 .
 This package contains the library itself, and a command-line tool to
 ease the generation of PostScript or PDF figures directly from .ml
 files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/ocaml.mk

DESTDIR = $(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)/mlpost
PREFIX = $(CURDIR)/debian/tmp/usr
DEB_INSTALL_DIRS_ALL = -Pdebian/tmp
DEB_MAKE_INSTALL_TARGET = install LIBDIR=$(DESTDIR) prefix=$(PREFIX)
DEB_MAKE_BUILD_TARGET = all doc
OCAML_DHOCAML_FLAGS = --runtime-map mlpost

EXAMPLES_TARBALL = debian/examples.tar.gz

pre-build::
	tar -czf $(EXAMPLES_TARBALL) --exclude=parse.ml examples

clean::
	rm -Rf $(EXAMPLES_TARBALL)

## mlpost 0.8.1

=== customdoc/Makefile ===
img.cmo: img.ml
	ocamlc -I +ocamldoc -c -dtypes img.ml

=== examples/Makefile ===
MAX := 17
# all files that are generated from boxes.ml
BOXESPNG := $(foreach i,$(shell seq 1 9), boxes$(i).png)

# all files that are generated from paths.ml
PATHSPNG := $(foreach i,$(shell seq 1 17), paths$(i).png)

# all files that are generated from misc.ml
MISCPNG := $(foreach i,1 2 $(shell seq 4 9) $(shell seq 11 14), misc$(i).png)

# all files that are generated from tree.ml
TREEPNG := $(foreach i,$(shell seq 1 14), tree$(i).png)


# all files that are generated from label.ml
LABELPNG := $(foreach i,$(shell seq 1 2), label$(i).png)

# all files that are generated from automata.ml
AUTOMPNG := automata1.png automata2.png automata4.png

HISTPNG := hist1.png

RADARPNG := radar1.png radar2.png

REALPLOTPNG := real_plot1.png real_plot2.png

COLORPNG := color1.png color2.png color3.png color4.png

INCLUDEPNG := include1.png include2.png include3.png

DOTPNG := dot_dot1.png dot_dot2.png

HTMLFILES := boxes.ml.html paths.ml.html misc.ml.html tree.ml.html \
             label.ml.html automata.ml.html hist.ml.html radar.ml.html\
	     real_plot.ml.html dot_dot.ml.html color.ml.html include.ml.html

MLPOST:=mlpost -v -ps

ALL := $(BOXESPNG) $(PATHSPNG) $(MISCPNG) $(TREEPNG) $(LABELPNG) $(AUTOMPNG)\
	$(HISTPNG)  $(RADARPNG) $(REALPLOTPNG) $(COLORPNG) $(INCLUDEPNG)

ALL_CAIRO := $(addprefix cairo_,$(ALL))

ALL_CAIRO_PNG := $(addprefix png_,$(ALL_CAIRO))

ALL_CAIRO_PDF := $(addprefix pdf_,$(ALL_CAIRO))

ALL_CAIRO_PS := $(addprefix ps_,$(ALL_CAIRO))
ALL_CAIRO_SVG := $(addprefix svg_,$(ALL_CAIRO:.png=.svg))

all : all_metapost all_cairo

all_metapost: $(ALL)
all_cairo: all_cairo_png all_cairo_ps all_cairo_pdf all_cairo_svg

all_cairo_png:  $(ALL_CAIRO_PNG)
all_cairo_pdf:  $(ALL_CAIRO_PDF)
all_cairo_ps:  $(ALL_CAIRO_PS)
all_cairo_svg:  $(ALL_CAIRO_SVG)


contrib:$(DOTPNG)\
	$(addprefix png_cairo_,$(DOTPNG))\
	$(addprefix pdf_cairo_,$(DOTPNG))\
	$(addprefix ps_cairo_,$(DOTPNG))\
	$(addprefix svg_cairo_,$(DOTPNG:png=svg))

#Compilation
%_dot.native : %_dot.ml
	$(MLPOST) -native -contrib dot -dont-execute -compile-name $@ $^

%.native : %.ml
	$(MLPOST) -native -dont-execute -compile-name $@ $^

#With Metapost :
$(foreach i,$(shell seq 1 $(MAX)), %$(i).1) : %.native
	./$^ -ps

#With cairo pdf
$(foreach i,$(shell seq 1 $(MAX)), pdf_cairo_%$(i).pdf) : %.native
	./$^ -pdf -cairo -prefix "pdf_cairo_"

#With cairo ps
$(foreach i,$(shell seq 1 $(MAX)), ps_cairo_%$(i).ps) : %.native
	./$^ -ps -cairo -prefix "ps_cairo_"

#With cairo png
$(foreach i,$(shell seq 1 $(MAX)), png_cairo_%$(i).png) : %.native
	./$^ -png -cairo -prefix "png_cairo_"

#With cairo svg
$(foreach i,$(shell seq 1 $(MAX)), svg_cairo_%$(i).svg) : %.native
	./$^ -svg -cairo -prefix "svg_cairo_"

parse.ml: parse.mll
	ocamllex parse.mll

parse: parse.ml
	ocamlopt.opt -o parse parse.ml

#Other
html: $(HTMLFILES)
%.ml.html : %.ml parse style.css
	caml2html -css -hc -ext "parse:./parse" $*.ml


%.png: %.ps
	convert $^  $@

%.png: %.pdf
	convert $^  $@

%.tex: all.template
	sed -e 's/all/$*/' all.template > $@

%.ps: %.1 %.tex
	latex $*
	dvips -E $*.dvi -o

# %.pdf: %.mps all.template2
# 	sed -e 's/all/$*/' all.template2 > $*.tex
# 	pdflatex $*

# %.mps: %.1
# 	cp $*.1 $*.mps

ALLTEX:=$(ALL:.png=.tex)

clean:
	rm -f *.aux *.dvi *.ps *.1 *.log $(PNGFILES) *.mp *.mpx *.mps *.pdf
	rm -f $(ALLTEX)
	rm -f $(HTML)
	rm -f parse.ml *.cmx *.cmo *.cmi parse *.o
	rm -f *.dummy *.dummy_dot *.native *.annot
	rm -f $(filter-out powered-by-caml.128x58.png,$(wildcard *.png))


editor2 :
	ocamlbuild editor2.native

lattice_lablgtk : lattice_lablgtk.ml
	$(MLPOST) -contrib lablgtk lattice_lablgtk.ml

=== debian/changelog ===
mlpost (0.8.1-8build1) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:39:49 +0200

mlpost (0.8.1-8) unstable; urgency=medium

  * Disable configure check that ocamlbuild has the same version as
    ocaml

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jul 2017 19:30:20 +0200

mlpost (0.8.1-7) unstable; urgency=medium

  [ Mehdi Dogguy ]
  * Update watch file

  [ Stéphane Glondu ]
  * Add ocamlbuild to Build-Depends
  * Bump debhelper compat to 10
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2017 17:43:54 +0200

mlpost (0.8.1-6) unstable; urgency=low

  * Team upload.
  * Added build-dependency on texlive-fonts-recommended (closes: #738389)

 -- Ralf Treinen <treinen@debian.org>  Mon, 10 Feb 2014 20:32:35 +0100

mlpost (0.8.1-5) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Wed, 04 Dec 2013 23:31:12 +0100

mlpost (0.8.1-4) experimental; urgency=low

  * Compile with OCaml >= 4.01
  * debian/patches:
    + Fix for ocamldoc >= 4
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Nov 2013 10:18:06 +0100

mlpost (0.8.1-3) unstable; urgency=low

  * Team upload.
  * Since context (>= 2012.05.23.20120524-1), mp-tool.mp and mp-spec.mp
    are no longer provided. Instead, context provide .mpii and .mpiv files.
    - add 0005-Fully-qualify-name-of-input-ed-files.patch
    - {build-,}depend on context (>= 2012.05.23.20120524-1~)
    (Closes: #676116, #676127).
  * Use Breaks instead of Conflicts with mlpost (<< 0.8.1).
  * Bump Standards-Version to 3.9.3 (no changes)

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 12 Jun 2012 18:12:17 +0200

mlpost (0.8.1-2) unstable; urgency=low

  * Set OCAMLFIND_DESTDIR at configure time, so that the paths compiled
    into the mlpost tool are correct

 -- Stéphane Glondu <glondu@debian.org>  Mon, 24 May 2010 17:23:04 +0200

mlpost (0.8.1-1) unstable; urgency=low

  * New upstream release
    - debian/patches:
      + remove 0001-No-tracingchoices-in-generated-MetaPost-sources.patch
      + add 0001-Do-not-remove-ocamlbuild.Makefile.patch
      + add 0002-Create-man-dir-before-installing-into-it.patch
      + add 0003-Fix-hyphen-escapes-in-manpage.patch
      + add 0004-myocamlmacroparser-use-.byte-instead-of-.native.patch
  * New binary packages:
    - libmlpost-ocaml-dev: library files, as per regular OCaml library
      packaging
    - libmlpost-ocaml-doc: architecture-independent documentation, and
      therefore reduce build-dependencies for arch-dep packages
      (Closes: #564779)
    - mlpost: mlpost tool and its manpage
  * Switch debian/rules to dh with overrides, and drop build-dependency to
    cdbs
  * Bump Standards-Version to 3.8.4 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 May 2010 22:31:56 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk
PREFIX = $(CURDIR)/debian/tmp
OCAMLFIND_DESTDIR = $(PREFIX)$(OCAML_STDLIB_DIR)

EXAMPLES_TARBALL = debian/examples.tar.gz

%:
	dh $@ --with ocaml

$(EXAMPLES_TARBALL):
	tar -czf $(EXAMPLES_TARBALL) --exclude=parse.ml examples

.PHONY: override_dh_auto_configure
override_dh_auto_configure: $(EXAMPLES_TARBALL)
	OCAMLFIND_DESTDIR=$(OCAML_STDLIB_DIR) ./configure --prefix=$(PREFIX)/usr

.PHONY: override_dh_auto_install
override_dh_auto_install:
ifneq (,$(findstring libmlpost-ocaml-doc,$(shell dh_listpackages)))
	$(MAKE) doc
endif
	mkdir -p $(OCAMLFIND_DESTDIR)
	$(MAKE) DESTDIR="-destdir $(OCAMLFIND_DESTDIR)" install

.PHONY: override_dh_auto_test
override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
  https://github.com/backtracking/mlpost/tags \
  (?:.*?/)?version-(\d[\d.]*)\.tar\.gz debian uupdate

## mlpost 0.8.2

=== dvi/Makefile ===
OCAMLBUILD := ocamlbuild -cflag "-dtypes"
all:
	$(OCAMLBUILD) dev_save.cmx

clean:
	$(OCAMLBUILD) -clean

doc:
	$(OCAMLBUILD) dvi.docdir/index.html

=== multi-examples/Makefile ===
MLFILES := $(shell echo *.ml)
MLFILES := $(MLFILES:myocamlbuild.ml=)
MLFILES := $(MLFILES:examples.ml=)

BUILD = _build/

OCAMLBUILD := ocamlbuild
ifeq ($(TERM), dumb)
	OCAMLBUILD := $(OCAMLBUILD) -classic-display
endif
ifneq ($(BUILD), _build/)
	OCAMLBUILD := $(OCAMLBUILD) -build-dir $(BUILD)
endif

HTML = $(BUILD)examples.html

all:
	$(OCAMLBUILD) $(MLFILES:.ml=.htmlpart)
	echo "<html><head><title>Mlpost Examples</title></head>" > $(HTML)
	echo "<body><h1>Mlpost Examples</h1>" >> $(HTML)
	cat $(BUILD)*.htmlpart >> $(HTML)
	echo "</body></html>" >> $(HTML)

clean:
	$(OCAMLBUILD) -clean
	rm -f *~

.PHONY: all

=== www/Makefile ===

WWW = /users/www-perso/projets/mlpost/

GENERATED := index.fr.html  index.en.html index.de.html \
	   manual.fr.html manual.en.html manual.de.html

ALL:= $(GENERATED) slides-jfla.pdf mlpost-jfla.pdf

install: all
	cp -f --parents $(ALL) $(WWW)

export: all
	scp $(ALL) filliatr@pl-ssh2.lri.fr:/users/www-perso/projets/mlpost/

all: $(ALL)

$(GENERATED): macros.prehtml version.prehtml

# RULES

YAMLPP=yamlpp macros.prehtml version.prehtml

.SUFFIXES: .html .prehtml .fr.html .en.html

%.fr.html: %.prehtml
	$(YAMLPP) -l fr $< -o $@

%.en.html: %.prehtml
	$(YAMLPP) -l en $< -o $@

%.de.html: %.prehtml
	$(YAMLPP) -l de $< -o $@

clean:
	rm -f $(GENERATED)

=== contrib/dot/Makefile ===
BUILD=_build

# TO suppress
OCAMLBUILD=ocamlbuild
OCAMLFIND=ocamlfind

all :
	$(OCAMLBUILD) -I $(MLPOST_LIB) -tag dtypes  -no-links mlpost_dot.cma mlpost_dot.cmxa mlpost_dot.a dot.cmi -classic-display

install : 
	$(OCAMLFIND) remove mlpost_dot
	$(OCAMLFIND) install mlpost_dot $(BUILD)/mlpost_dot.cma $(BUILD)/mlpost_dot.cmxa $(BUILD)/mlpost_dot.a $(BUILD)/dot.cmi META

clean :
	$(OCAMLBUILD) -clean

=== papers/jfla2009/Makefile ===

all: hermann-pp.pdf

PDFLATEX:=pdflatex -interaction="errorstopmode"

WWW=/users/demons/filliatr/WWW

main-pp.pdf: main-pp.tex biblio.bib figures.mp figmp.mps yannick1.mps florence.mps
	pdflatex $<
	bibtex main-pp
	pdflatex $<
	bibtex main-pp
	pdflatex $<
	pdflatex $<

hermann-pp.pdf: hermann-pp.tex biblio.bib figures.mp figmp.mps yannick1.mps florence.mps
	$(PDFLATEX) $<
#	bibtex hermann-pp
#	$(PDFLATEX) $<
#	bibtex hermann-pp
#       $(PDFLATEX) $<
#       $(PDFLATEX) $<

slides.pdf: slides.tex figures.mp alt_ergo.mp
	pdflatex $<

%-pp.tex: pp.ml %.tex 
	ocaml $^ > $@

wc:
	grep -iw frametitle slides.tex | wc -l

%.mp: %.ml
	../../_build/tool.native -ccopt "-I ../../" -pdf -latex main.tex $^

figmp.mps: figmp.mp
	mpost figmp.mp end
	mv figmp.1 figmp.mps

yannick1.mps: yannick1.1
	cp $^ $@

florence.mps: florence.1
	cp $^ $@

main-pp.dvi: main-pp.tex
	latex $^

pp.ml: pp.mll
	ocamllex pp.mll

print: main-pp.ps
	lpr $^

export: main-pp.pdf
	cp -f main-pp.pdf $(WWW)/publis/mlpost-fra.pdf

clean:
	rm -f *~ *.aux *.log *.bbl *.blg *.mps
	rm -f main-pp.dvi main-pp.ps figures.mp
	rm -f mpxerr.dvi mpxerr.tex main-pp.pdf

=== papers/ter-stage/Makefile ===

all: slides.pdf

PDFLATEX:=pdflatex -interaction="errorstopmode"

rapport.pdf: rapport.tex figrapport.mp
	pdflatex $<
	pdflatex $<

slides.pdf: slides.tex figrapport.mp 
	pdflatex $<

wc:
	grep -iw frametitle slides.tex | wc -l

%.mp: %.ml
	../../tool.opt -ccopt "-I ../../" -pdf -latex rapport.tex $^

test:
	../../tool.opt -ccopt "-I ../../" -xpdf -latex slides.tex figrapport.ml

clean:
	rm -f *~ *.aux *.log *.bbl *.blg *.mps
	rm -f rapport.dvi rapport.ps figrapport.mp
	rm -f mpxerr.dvi mpxerr.tex rapport.pdf

=== test/externalimage/Makefile ===
all : latex beamer

latex: powered-by-caml.png images externalimage.tex
	pdflatex externalimage.tex

beamer: powered-by-caml.png images externalimage_beamer.tex
	pdflatex externalimage_beamer.tex

images : externalimage.ml
	../../tool.opt -ccopt "-I ../../" -pdf externalimage.ml

clean:
	rm -f *.pdf *.aux *.log *.mp *.mps *.1 *.nav *.out *.toc *.snm

=== test/manual/Makefile ===
mpost:
	mpost manual.mp end

mps : mpost
	./convert_to_mps.sh

clean:
	rm -f manual.[0-9]* manual.[0-9] *.mps manual.log manual.mpx

=== test/othergraphs/Makefile ===
mpost:
	mpost mpost.mp end

mps : mpost
	./convert_to_mps.sh

clean:
	rm -f manual.[0-9]* manual.[0-9] *.mps manual.log manual.mpx

=== debian/changelog ===
mlpost (0.8.2-2ubuntu1) focal; urgency=medium

  * Disable doc build, as it ftbfs due to insecure image/ps conversion.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Feb 2020 14:09:10 +0000

mlpost (0.8.2-2) unstable; urgency=medium

  * Fix compilation with bitstring 3.1.1 (Closes: #949926)
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Thu, 30 Jan 2020 17:21:50 +0100

mlpost (0.8.2-1) unstable; urgency=medium

  * New upstream release
  * Fix compilation with OCaml 4.08.1
  * Update debian/watch
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Nov 2019 16:08:35 +0100

=== debian/control ===
Source: mlpost
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 libcairo-ocaml-dev,
 libbitstring-ocaml-dev (>= 3),
 ocaml-findlib,
 ocamlbuild,
 cppo,
 ocaml-nox (>= 4.08),
 dh-ocaml
Build-Depends-Indep:
 context,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-fonts-recommended,
 texlive-metapost,
 ghostscript,
 imagemagick
Standards-Version: 4.5.0
Rules-Requires-Root: no
Section: tex
Homepage: http://mlpost.lri.fr/
Vcs-Browser: https://salsa.debian.org/ocaml-team/mlpost
Vcs-Git: https://salsa.debian.org/ocaml-team/mlpost.git

Package: mlpost
Architecture: any
Depends:
 context,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-metapost,
 libmlpost-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 xpdf
Suggests:
 ghostscript,
 imagemagick,
 ocaml-findlib
Description: OCaml interface to Metapost (command-line tool)
 Mlpost is an OCaml library for scientific drawing. It relies on
 Metapost, giving the possibility to include (La)TeX fragments.
 Mlpost users can use the full power of OCaml to generate their
 diagrams, including static typing and the possibility to use any
 OCaml library. Moreover, Mlpost promotes a declarative style quite
 different from existing tools.
 .
 This package contains a command-line tool to ease the generation of
 PostScript or PDF figures directly from .ml files.

Package: libmlpost-ocaml-dev
Section: ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Suggests:
 context,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-metapost,
 xpdf,
 ghostscript,
 imagemagick
Description: OCaml interface to Metapost (library)
 Mlpost is an OCaml library for scientific drawing. It relies on
 Metapost, giving the possibility to include (La)TeX fragments.
 Mlpost users can use the full power of OCaml to generate their
 diagrams, including static typing and the possibility to use any
 OCaml library. Moreover, Mlpost promotes a declarative style quite
 different from existing tools.
 .
 This package contains the library itself.

#Package: libmlpost-ocaml-doc
#Section: doc
#Architecture: all
#Depends: ${misc:Depends}
#Enhances: libmlpost-ocaml-dev
#Description: Objective Caml interface to Metapost (doc)
# Mlpost is an OCaml library for scientific drawing. It relies on
# Metapost, giving the possibility to include (La)TeX fragments.
# Mlpost users can use the full power of OCaml to generate their
# diagrams, including static typing and the possibility to use any
# OCaml library. Moreover, Mlpost promotes a declarative style quite
# different from existing tools.
# .
# This package contains the API reference of the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk
PREFIX = $(CURDIR)/debian/tmp

export OCAMLFIND_DESTDIR = $(PREFIX)$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF = ignore

EXAMPLES_TARBALL = debian/examples.tar.gz

%:
	dh $@ --with ocaml

$(EXAMPLES_TARBALL):
	tar -czf $(EXAMPLES_TARBALL) --exclude=parse.ml examples

override_dh_auto_configure: $(EXAMPLES_TARBALL)
	./configure --prefix=$(PREFIX)/usr

override_dh_auto_install:
ifneq (,$(findstring libmlpost-ocaml-doc,$(shell dh_listpackages)))
	$(MAKE) doc
endif
	mkdir -p $(OCAMLFIND_DESTDIR)
	$(MAKE) install

override_dh_auto_test:

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
https://github.com/backtracking/mlpost/releases .*/(?:version-|origin/v)?(\d[\d.]*)\.tar\.gz

## mlpost 0.9

=== Makefile ===
##########################################################################
#                                                                        #
#  Copyright (C) Johannes Kanig, Stephane Lescuyer                       #
#  Jean-Christophe Filliatre, Romain Bardou and Francois Bobot           #
#                                                                        #
#  This software is free software; you can redistribute it and/or        #
#  modify it under the terms of the GNU Library General Public           #
#  License version 2.1, with the special exception on linking            #
#  described in file LICENSE.                                            #
#                                                                        #
#  This software is distributed in the hope that it will be useful,      #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  #
#                                                                        #
##########################################################################

.PHONY: all test clean

all:
	dune build @install

test:
	dune runtest

doc:
	dune build @doc

# When adding new figures or examples
promote:
	dune build @promote --auto-promote || true  #For dune.inc
	dune build @promote --auto-promote || true  #For *.dune.inc
	dune runtest

headers:
	headache -c headache_config.txt -h header.txt \
	version/*.ml* README.txt tools/*.ml tools/*.ml[iyl] src/*.ml src/*.ml[iyl]

clean:
	dune clean

## Install should be replaced when `dune install` is improved (e.g. DESTDIR support)
install:
	dune install

release:
	@echo "Only the committed code is added in the archive, VERSION is \"$(VERSION)\""
	git archive --format=tar.gz --prefix mlpost-$(VERSION)/ -o mlpost-$(VERSION).tar.gz HEAD

fmt:
	dune build @fmt --auto-promote

=== examples/Makefile ===
--- 
+++ 
@@ -39,6 +39,9 @@
 ALL := $(BOXESPNG) $(PATHSPNG) $(MISCPNG) $(TREEPNG) $(LABELPNG) $(AUTOMPNG)\
 	$(HISTPNG)  $(RADARPNG) $(REALPLOTPNG) $(COLORPNG) $(INCLUDEPNG)
 
+#Direct mps output
+ALL_MPS :=  $(addprefix mps_,$(ALL))
+
 ALL_CAIRO := $(addprefix cairo_,$(ALL))
 
 ALL_CAIRO_PNG := $(addprefix png_,$(ALL_CAIRO))
@@ -48,9 +51,11 @@
 ALL_CAIRO_PS := $(addprefix ps_,$(ALL_CAIRO))
 ALL_CAIRO_SVG := $(addprefix svg_,$(ALL_CAIRO:.png=.svg))
 
-all : all_metapost all_cairo
+all : all_metapost all_cairo all_mps
 
 all_metapost: $(ALL)
+all_mps: $(ALL_MPS)
+
 all_cairo: all_cairo_png all_cairo_ps all_cairo_pdf all_cairo_svg
 
 all_cairo_png:  $(ALL_CAIRO_PNG)
@@ -58,6 +63,8 @@
 all_cairo_ps:  $(ALL_CAIRO_PS)
 all_cairo_svg:  $(ALL_CAIRO_SVG)
 
+.PHONY: all all_metapost all_mps all_cairo all_cairo_png all_cairo_pdf \
+	all_cairo_ps all_cairo_svg
 
 contrib:$(DOTPNG)\
 	$(addprefix png_cairo_,$(DOTPNG))\
@@ -75,6 +82,10 @@
 #With Metapost :
 $(foreach i,$(shell seq 1 $(MAX)), %$(i).1) : %.native
 	./$^ -ps
+
+#With direct mps output :
+$(foreach i,$(shell seq 1 $(MAX)), mps_%$(i).mps) : %.native
+	./$^ -mps -prefix "mps_"
 
 #With cairo pdf
 $(foreach i,$(shell seq 1 $(MAX)), pdf_cairo_%$(i).pdf) : %.native
@@ -110,12 +121,19 @@
 %.png: %.pdf
 	convert $^  $@
 
+%.pdf.tex: all.pdf.template
+	sed -e 's/all/$*/' all.pdf.template > $@
+
 %.tex: all.template
 	sed -e 's/all/$*/' all.template > $@
 
 %.ps: %.1 %.tex
 	latex $*
 	dvips -E $*.dvi -o
+
+%.pdf: %.mps %.pdf.tex
+	pdflatex $*.pdf.tex
+	mv $*.pdf.pdf $*.pdf
 
 # %.pdf: %.mps all.template2
 # 	sed -e 's/all/$*/' all.template2 > $*.tex
@@ -124,7 +142,7 @@
 # %.mps: %.1
 # 	cp $*.1 $*.mps
 
-ALLTEX:=$(ALL:.png=.tex)
+ALLTEX:=$(ALL:.png=.tex) $(ALL_MPS:.png=.pdf.tex)
 
 clean:
 	rm -f *.aux *.dvi *.ps *.1 *.log $(PNGFILES) *.mp *.mpx *.mps *.pdf

=== test/Makefile ===
manual: testmanual.pdf

testmanual.pdf: testmanual.tex
	#mpost testmanual.mp end
	make -C manual mps
	pdflatex testmanual.tex
	#dvips testmanual.dvi -o testmanual.ps

other: othergraphs.tex
	#mpost othergraphs.mp end
	make -C othergraphs mps
	pdflatex othergraphs.tex
	#dvips othergraphs.dvi -o othergraphs.ps

tests: tests.dvi
	dvips tests.dvi -o tests.ps

testbox: testbox.dvi
	dvips testbox.dvi -o testbox.ps

%.dvi: %.mp
	mpost $*.mp end
	latex $*

tests.pdf: tests.dvi
	dvipdf tests.dvi


clean: 
	make -C manual clean
	make -C othergraphs clean
	rm -f testmanual.*
	rm -f testmanual_cairo-*.*
	rm -f tests.* *.mps *.pdf
	rm -f othergraphs.*

=== presentations/proval/Makefile ===
MPSFILES := cfg proval mpex colortriangle path cheno pictures tree2 \
		tree6 florence
MPSFILES := $(patsubst %,%.mps, $(MPSFILES))

GENERATED := cfg proval colortriangle path cheno pictures tree2 tree6
GENERATED := $(patsubst %,%.mp, $(GENERATED))

pdf: slides.pdf

slides.pdf: $(MPSFILES) slides.tex
	pdflatex slides.tex
	pdflatex slides.tex

%.mps: %.ml
	mlpost -pdf -latex slides.tex $^

clean:
	rm -f *.toc *.aux *.pdf *.log *~ *.mp[sx] *.snm *.nav *.out
	rm -f $(GENERATED)

%.mps: %.1
	mv $^ $@

%.1: %.mp
	mpost $^ end

=== presentations/workshop-ml-2009/Makefile ===
all: slides.pdf

FIGURES:= fibtree.pdf

$(FIGURES): figures.ml
	mlpost -cairo $<
	make -C ../../papers/jfla2009/ figures.mp

view: slides.pdf
	xpdf slides.pdf

slides.pdf: $(FIGURES) slides.tex

%.pdf: %.tex
	pdflatex $<

=== debian/changelog ===
mlpost (0.9-4) unstable; urgency=medium

  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Aug 2023 09:41:12 +0200

mlpost (0.9-3) unstable; urgency=medium

  * Team upload.
  * Fix d/watch.
  * Bump standards-version to 4.6.2
  * Fix compilation with recent dune

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 14:53:38 +0200

mlpost (0.9-2) unstable; urgency=medium

  * Apply upstream patch to upgrade to ppxlib (Closes: #1002984)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jan 2022 06:49:41 +0100

mlpost (0.9-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Fri, 03 Dec 2021 16:37:53 +0100

mlpost (0.8.2-4) unstable; urgency=medium

  * Add empty dh_dwz override to fix FTBFS

 -- Stéphane Glondu <glondu@debian.org>  Tue, 28 Jul 2020 10:43:05 +0200

mlpost (0.8.2-3) unstable; urgency=medium

  * Fix wrong path to mlpost.cma (Closes: #961529)
  * Recompile with new dependencies (Closes: #966346)
  * Bump debhelper compat level to 13
  * libmlpost-ocaml-doc: add Multi-Arch: foreign

 -- Stéphane Glondu <glondu@debian.org>  Mon, 27 Jul 2020 16:13:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,30 @@
 Source: mlpost
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
- libcairo-ocaml-dev,
+ debhelper-compat (= 13),
+ libcairo2-ocaml-dev,
+ libcairo2-dev,
  libbitstring-ocaml-dev (>= 3),
+ ocaml-dune,
+ libdune-ocaml-dev,
+ libppxlib-ocaml-dev (>= 0.20.0),
  ocaml-findlib,
- ocamlbuild,
- cppo,
- ocaml-nox (>= 4.08),
- dh-ocaml
-Build-Depends-Indep:
+ ocaml,
+ dh-ocaml (>= 1.2),
+ ocaml-odoc,
+ poppler-utils,
+ graphviz,
  context,
  texlive-latex-base,
  texlive-latex-recommended,
+ texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-metapost,
  ghostscript,
  imagemagick
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: tex
 Homepage: http://mlpost.lri.fr/
@@ -39,6 +43,7 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends:
+ libmlpost-ocaml-doc,
  xpdf
 Suggests:
  ghostscript,
@@ -64,6 +69,7 @@
  ${misc:Depends}
 Provides: ${ocaml:Provides}
 Recommends:
+ libmlpost-ocaml-doc,
  ocaml-findlib
 Suggests:
  context,
@@ -83,17 +89,18 @@
  .
  This package contains the library itself.
 
-#Package: libmlpost-ocaml-doc
-#Section: doc
-#Architecture: all
-#Depends: ${misc:Depends}
-#Enhances: libmlpost-ocaml-dev
-#Description: Objective Caml interface to Metapost (doc)
-# Mlpost is an OCaml library for scientific drawing. It relies on
-# Metapost, giving the possibility to include (La)TeX fragments.
-# Mlpost users can use the full power of OCaml to generate their
-# diagrams, including static typing and the possibility to use any
-# OCaml library. Moreover, Mlpost promotes a declarative style quite
-# different from existing tools.
-# .
-# This package contains the API reference of the library.
+Package: libmlpost-ocaml-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Enhances: libmlpost-ocaml-dev
+Description: Objective Caml interface to Metapost (doc)
+ Mlpost is an OCaml library for scientific drawing. It relies on
+ Metapost, giving the possibility to include (La)TeX fragments.
+ Mlpost users can use the full power of OCaml to generate their
+ diagrams, including static typing and the possibility to use any
+ OCaml library. Moreover, Mlpost promotes a declarative style quite
+ different from existing tools.
+ .
+ This package contains the API reference of the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

override_dh_auto_build:
	dune build -p $(shell cat debian/debian-dune) @install @doc
